#include <iostream>
#include <unistd.h>
#include <chai.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdarg.h>
#include <time.h>


// Определение констант
using namespace std;
int chan1 = 0;
int chan2 = 1;
const char ver[] = "chaitest ver. 2.8, 01 Sep 2016";
const int FRAMES_COUNT = 100;




// функция получения текущего системного времени в миллисекундах 
#define msleep(msec) usleep(msec*1000)
unsigned long long get_systime_in_msecs(void) 
{
    struct timeval tv;
    unsigned long long msecs = 0;

    gettimeofday(&tv, NULL);
    msecs = (unsigned long long) tv.tv_sec * 1000ULL;
    msecs += (unsigned long long) tv.tv_usec / 1000ULL;
    return msecs;
}

// функция измерения времени выполнения вызванной функции и вывод результата в терминал связанна с get_systime_in_msecs
void time_measure(void (*func) (void), char *msg) 
{
    unsigned long long begint, finisht, difft;

    printf("%s: ", msg);
    fflush(stdout);
    begint = get_systime_in_msecs();

    func();

    finisht = get_systime_in_msecs();
    difft = finisht - begint;
    printf("(complete in %lu millisecs)\n", (unsigned long) difft);
    fflush(stdout);
} 

void W_Write(void)
{

	const int FRAMES_COUNT = 100;
		canmsg_t frames[FRAMES_COUNT];
		for (int i = 0; i < FRAMES_COUNT; ++i) {
			msg_zero(&frames[i]);
			frames[i].id = i;
			frames[i].len = 1;
			frames[i].data[0] =250;
		}

 	int16_t ret = 0;
		for (int i = 0; i < FRAMES_COUNT; ++i) {
			CiWrite(chan1, &frames[i], FRAMES_COUNT);
			if (ret <= 0)
				printf("Sending frame %d failed\n", i);
		
//		printf("Send frame: id = %d; data = %d\n", frames[i].id, frames[i].data[0]);
		}
	usleep(40000);
}







int main()
{

	// инициализация chai
	if (CiInit() < 0) {
		printf("CHAI library initialization failed\n");
		return 1;
	}

	// данные для отправки
	

	// открытие устройств и запуск chai
	if (CiOpen(chan1, CIO_CAN11 | CIO_CAN29) < 0) {
		printf("Failed to open channel %d\n", chan1);
		return 1;
	}

	if (CiOpen(chan2, CIO_CAN11 | CIO_CAN29) < 0) {
		printf("Failed to open channel %d\n", chan2);
		return 1;
	}
	if (CiStart(chan1) < 0) {
		printf("Failed to start chai on channel %d\n", chan1);
		return 1;
	}

//        tcall(CiStart(chan1), "CiStart failed");
	if (CiStart(chan2) < 0) {
		printf("Failed to start chai on channel %d\n", chan2);
		return 1;
	}

	// отправка
	
        W_Write();

	// чтение
	
	
	
	int16_t ret = 0
	canmsg_t frames_in[FRAMES_COUNT];
	for (int i = 0; i < FRAMES_COUNT; ++i)
		msg_zero(&frames_in[i]);

	ret = CiRead(chan2, &frames_in[0], FRAMES_COUNT);
	printf("Got %d frames\n", ret);

	for (int i = 0; i < FRAMES_COUNT; ++i)
		printf("Got frame: id = %d; data = %d\n", frames_in[i].id, frames_in[i].data[0]);


	// остановка chai
	CiStop(chan1);
	CiStop(chan2);
	// конфигурация каналов
	printf("\nTestTool\n"); 
		
	CiClose(chan1);
	CiClose(chan2);

	return 0;
}

